/*
    Copyright 2004,2005,2006 Luigi Auriemma

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA

    http://www.gnu.org/licenses/gpl.txt

*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <windows.h>



#define VER         "0.1.1"
#define ENCDATA     "Copyright  1999-2004 Jan G.P. Sijm"
#define KEYPATH     "Software\\Jan G.P. Sijm\\Poppy for Windows\\Accounts\\%d"
#define BUFFSZ      4096



int readreg(HKEY key, u_char *buff, u_char *value);
void poppy_pwd(u_char *pwd);



int main(void) {
    HKEY    key;
    u_char  keybuff[BUFFSZ],
            value[BUFFSZ];
    int     i;


    setbuf(stdout, NULL);

    fputs("\n"
        "Poppy passwords decoder "VER"\n"
        "by Luigi Auriemma\n"
        "e-mail: aluigi@autistici.org\n"
        "web:    aluigi.org\n"
        "\n", stdout);

    for(i = 0; ; i++) {
        sprintf(keybuff, KEYPATH, i);

        if(RegOpenKeyEx(HKEY_CURRENT_USER, keybuff, 0, KEY_READ, &key)) break;

        if(readreg(key, value, "Name") < 0) break;
        printf("\nAccount:    %s\n", value);

        if(readreg(key, value, "Host") < 0) break;
        printf("Server:     %s:", value);

        if(readreg(key, value, "Port") < 0) break;
        printf("%d\n", *(int *)value);

        if(readreg(key, value, "User") < 0) break;
        printf("Username:   %s\n", value);

        if(readreg(key, value, "Password") < 0) break;
        poppy_pwd(value);
        printf("Password:   %s\n", value);

        RegCloseKey(key);
    }

    if(!i) {
        fputs("\nNo registry keys found\n", stdout);
    }

    fputs("\n\n    Press RETURN to exit\n", stdout);
    fgetc(stdin);
    return(0);
}



int readreg(HKEY key, u_char *buff, u_char *value) {
    int valuelen = BUFFSZ;

    if(RegQueryValueEx(
        key,
        value,
        NULL,
        NULL,
        buff,
        (void *)&valuelen)) return(-1);
    return(0);
}



void poppy_pwd(u_char *pwd) {
    u_char  *encdata = ENCDATA;

    while(*pwd) {
        *pwd = (*pwd - 1) ^ *encdata;
        pwd++;
        encdata++;
        if(!*encdata) encdata = ENCDATA;
    }
}

